<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <!-- Mask -->
            <span class="mask bg-gradient-primary opacity-8"></span>
        </base-header>

        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">Create user</h3>
                                    <span class="text-danger" v-if="error">{{error}}</span>
                                </div>
                            </div>
                        </div>
                        <template>
                            <form @submit="checkData">
                                <h6 class="heading-small text-muted mb-4">User information</h6>
                                <div class="pl-lg-4">
                                    <div class="row">
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="Username"
                                                        placeholder="Username"
                                                        input-classes="form-control-alternative"
                                                        v-model="username"
                                            />
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="First name"
                                                        placeholder="First name"
                                                        input-classes="form-control-alternative"
                                                        v-model="firstname"
                                            />
                                        </div>
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="Last name"
                                                        placeholder="Last name"
                                                        input-classes="form-control-alternative"
                                                        v-model="lastname"
                                            />
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="E-mail"
                                                        placeholder="info.nellehliving@gmail.com"
                                                        input-classes="form-control-alternative"
                                                        type="email"
                                                        v-model="email"
                                            />
                                        </div>
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="Organization"
                                                        placeholder="Organization"
                                                        input-classes="form-control-alternative"
                                                        v-model="organization_name"
                                            />
                                        </div>
                                    </div>
                                </div>
                                <hr class="my-4" />
                                <div class="text-center">
                                    <button class="btn btn-lg btn-primary" type="submit">Create</button>
                                </div>
                            </form>
                        </template>
                    </card>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
  export default {
    name: 'manage-users',
    data() {
      return {
        username :'',
        firstname :'',
        lastname : '',
        email : '',
        organization_name : '',
        message : '',
        error :''
      }
    },
    methods: {
        checkData(){
            if(this.username === ''){
                this.error = 'Please enter username'
            }else if(this.firstname == ''){
                this.error = 'Please enter first name'
            }else if(this.lastname == ''){
                this.error = 'Please enter Last name'
            }else if(this.email == ''){
                this.error = 'Please enter E-mail'
            }else if(this.organization_name == ''){
                this.error = 'Please enter Organization name'
            }else{
                this.createUser()
            }
        },
        createUser(){
            this.$http.post('/manage/users/create',{
                username: this.username,
                firstname: this.firstname,
                lastname: this.lastname,
                email: this.email,
                organization_name: this.organization_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Create Completed!",
                    text: "Username : " + response.data.username +
                    "\n Password : " + response.data.password +
                    "\n\n or check in user email." +
                    "\n \n Do you want to manage user page?!",
                    icon: "success",
                    buttons: {
                    cancel: "Cancel",
                    confirm: "Yes",
                }
                }).then((confirm) => {
                    if (confirm) {
                        this.$router.push('/manage')
                    } else {
                        location.reload()
                    }
                })
              }else if(response.data.message === 'cannot_username'){
                  this.error = 'This username cannot be used!'
              }
          })
          .catch(() => this.checkCreateUser())
        },
        checkCreateUser(){
            this.error = 'Create failed!!'
        }
    },
  };
</script>